#include <stdlib.h>
#include </usr/include/Fl/Fl.H>
#include </usr/include/Fl/Fl_Window.H>
#include </usr/include/Fl/Fl_Menu_Bar.H>
#include </usr/include/Fl/Fl_Widget.H>
#include </usr/include/Fl/Fl_Button.H>
#include </usr/include/Fl/Fl_File_Chooser.H>

#define TRUE 1
#define FALSE 0
#define WEAPONFIELDS 17
#define UNITFIELDS 34
#define COUNTRIES 38
#define WEAPONS 3000
#define UNITSDBLIMIT 20000
#define MAXLINELENGTH 4096
//#define BINARYOFFSET 0x519EA4
#define BINARYOFFSET 0x3C6AA4
//#define BINARYOFFSETU 0x49C224
#define BINARYOFFSETU 0x348E24
#define BINARYOFFSETUDB 0x0181B010
#define FORTSOFFSET 0x01802970  //tentative
#define AIRBASESOFFSET 0x017EA2D0 //tentative
#define CITIESOFFSET 0x017A0EBE //fixed
#define FIELDS 54
#define MAXNAMELENGTH 40
#define MAXUNITNAMELENGTH 33
#define MAXNAMELENGTHUDB 16
#define MAXNAMELENGTHOBJECT 39
#define UNITS 2820
#define WEAPONSIZE 0x6C
#define UNITSIZE 0x5C
#define UNITDBSIZE 0xC8
#define MAPTILESIZE 9
#define MAPOBJECTSIZE 50
#define FORCETYPES 3
#define MAXPICS 281
#define UNITTYPES 44
#define MAXUNITSIZELENGTH 3
#define SIZETYPES 3
#define MAPORIGIN 0x403
#define MAPCOLUMNS 2048
#define MAPROWS 1343
#define LATGRIDPOINTS 25
#define LONGRIDPOINTS 41
#define DEG 0
#define GRID 1
#define OFFMAP 30000
#define OFFMAP6 60000
#define XX 0
#define YY 1
#define XLON 0
#define YLAT 1
#define UNITDBFIELDS 63
#define OFFMAPFMAX -900

static unsigned short unitcoordinates[UNITSDBLIMIT][2];//used for detaching units
static float unitcoordinatesf[UNITSDBLIMIT][2];//used for detaching units
static char weaponnames[WEAPONS+1][MAXNAMELENGTH];//used to attach names of weapons to units database;
static char unitnames[UNITS+1][MAXNAMELENGTH];//used to attach names of units to scenario units database;
unsigned char unitOwnerIndex[UNITS+1];//used to attach unit owning country to database output
int isWeaponsNamesAvailable=FALSE;
int isUnitsNamesAvailable=FALSE;
const char *countries[COUNTRIES+2]={"NULL","Australia","Belgium","Bulgaria","Canada","China","Siam(Thailand)","Croatia","Czechoslovakia","Finland","France","France(Vichy)","Germany","Great Britain","Greece","Hungary","India","Iran(Persia)","Italy","Japan","Denmark","Mongolia","Netherlands","New Zealand","Norway","Iraq","Poland","Portugal","Romania","Slovakia","Spain-Franko","Spain-Republic","South Africa","Sweden","Switzerland","Turkey","USA","USSR","Yugoslavia","Neutral"};
const char *forcetype[FORCETYPES+1]={"NULL","land","sea","air"};
const char *colstring[UNITFIELDS+1]={"INVALID","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","AA","AB","AC","AD","AE","AF","AG","AH"};
const char *typestring[UNITTYPES+1]={"NULL","n/a","n/a","n/a","armor","cavalry","infantry","paratrooper","fortress infantry","artilllery","AA artillery","engineers","fortress artillery","n/a","n/a","n/a","n/a","n/a","n/a","n/a","n/a","carrier","small carrier","seaplane tender","battleship","ironclad","battlecruiser","heavy cruiser","light cruiser","destroyer","escort","ocean submarine","submarine","midget submarine","n/a","n/a","n/a","n/a","n/a","n/a","n/a","fighter","assault plane","bomber","heavy bomber"};
const char *sizestring[SIZETYPES+1]={"NUL","div","rgt","btl"};
const char weaponFormatOffsets[WEAPONFIELDS+1]
	{0x00,0x01,0x02,0x2A,0x2C,0x2E,0x30,0x32,0x34,0x36,0x38,0x3A,0x3C,0x3E,0x40,0x42,0x44,0x6A};
const char unitFormatOffsets[UNITFIELDS]
	{0x00,0x01,0x22,0x23,0x25,0x27,0x28,0x2A,0x2C,0x2E,0x30,0x32,0x34,0x36,0x38,0x3A,0x3C,0x3E,0x40,0x42,0x44,0x46,0x48,0x4A,0x4C,0x4E,0x50,0x52,0x54,0x55,0x57,0x59,0x5A,0x5B};
const short lat_interp[LATGRIDPOINTS][2]
	{{80,1},{65,231},{60,296},{55,339},{50,403},{45,455},{40,503},{35,551},{30,599},{20,683},{10,763},{5,803},{0,843},{-5,883},{-10,923},{-15,959},{-20,1003},{-30,1087},{-35,1133},{-40,1179},{-45,1227},{-50,1277},{-55,1327},{-56,1337}};
const short lon_interp[LONGRIDPOINTS][2]
	{{-170,1},{-165,19},{-160,47},{-150,103},{-140,159},{-130,215},{-120,271},{-110,327},{-100,383},{-90,439},{-80,495},{-70,551},{-60,607},{-50,663},{-40,720},{-10,904},{0,960},{10,1016},{20,1072},{25,1100},{30,1129},{40,1185},{50,1242},{60,1298},{70,1355},{80,1412},{90,1470},{100,1526},{110,1583},{120,1639},{130,1696},{140,1752},{145,1780},{150,1809},{160,1865},{165,1893},{170,1922},{175,1950},{180,1978},{185,2006},{190,2034}};	
	 unsigned char wclass;
	 unsigned char namelength;
	 char name[40+2];
	 unsigned short month;
	 unsigned short year;
	 unsigned short price;
	 short speed;
	 short maneurability;
	 short softattack;
	 short hardattack;
	 short airattack;
	 short grounddefence;
	 short airdefence;
	 short flag3E;
	 short range;
	 short flag42;
	 char country[COUNTRIES];
	 short canUpgrade;
	 
	 unsigned char countryU;
	 int pic;
	 unsigned char fast;
	 unsigned char x25_26;
	 unsigned char typeU;//1=land,2=sea;3=air
	 short x28_29;
	 unsigned short crews;
	 unsigned short infantry;
	 short cars;
	 short horses;
	 short MG;
	 short handAT;
	 short APC;
	 short armcars;
	 short tanks;
	 short aguns;
	 short ATG;
	 short lm;
	 short mm;
	 short hm;
	 short infart;
	 short ligart;
	 short hart;
	 short shart;
	 short MRL;
	 short laa;
	 short haa;
	 unsigned char speedu;
	 unsigned char classi;
	 unsigned char immob;
	 unsigned char unitsize;




float interpolate(short x0,short y0, short x1,short y1,short x)//interpolate map coordinates from custom map grid to the degrees
{
 float result=-1000;
 float a,b;
 if(x0==x1){result=((float)y0+(float)y1)/2;}
 if(x1>x0){
 	   a=((float)y1-(float)y0)/((float)x1-(float)x0);
	   b=-a*x0+y0;
	   result=a*x+b;
 	  }
 return result;	  
}

float getLatitude(unsigned short y)
{
     short grid_distanceM=OFFMAP;
     short grid_distanceP=OFFMAP;
     short x0,x1,y0,y1;//bounding grid box
     float lat;//extracted longitude and latitude of object
     int i;
     for(i=0;i<LATGRIDPOINTS;i++)
     {
      if((lat_interp[i][GRID]<=y)&&(y-lat_interp[i][GRID]<grid_distanceM)){grid_distanceM=y-lat_interp[i][GRID];x0=lat_interp[i][GRID];y0=lat_interp[i][DEG];}//bounding from lower grid value
      if((lat_interp[i][GRID]>=y)&&(lat_interp[i][GRID]-y<grid_distanceP)){grid_distanceP=lat_interp[i][GRID]-y;x1=lat_interp[i][GRID];y1=lat_interp[i][DEG];}//bounding from upper grid value
     }
     return lat=interpolate(x0,y0,x1,y1,y);//determining latitude from map grid
}

float getLongitude(unsigned short x)
{
     short grid_distanceM=OFFMAP;//resetting criterion of closest grid
     short grid_distanceP=OFFMAP; 
     short x0,x1,y0,y1;//bounding grid box
     float lon;//extracted longitude and latitude of object
     int i;
     for(i=0;i<LONGRIDPOINTS;i++)
     {
      if((lon_interp[i][GRID]<=x)&&(x-lon_interp[i][GRID]<grid_distanceM)){grid_distanceM=x-lon_interp[i][GRID];x0=lon_interp[i][GRID];y0=lon_interp[i][DEG];}//bounding from lower grid value
      if((lon_interp[i][GRID]>=x)&&(lon_interp[i][GRID]-x<grid_distanceP)){grid_distanceP=lon_interp[i][GRID]-x;x1=lon_interp[i][GRID];y1=lon_interp[i][DEG];}//bounding from upper grid value
     }
     return lon=interpolate(x0,y0,x1,y1,x);//determining longitude from map grid 
}	 

int a2i(const char * text, unsigned int * output) {
	if (! text) return 0;
	char * end;
	int number = strtol(text, &end, 10);
	if (end != text) {
		*output = (unsigned int)number;
		return 1;
	}
	return 0;
}
/*
char xstrtoc(char *line, char *delims)
{
 static char *saveline=NULL;
 char *p;
 int n;
 if(line!=NULL){saveline=line;}
 if((saveline==NULL))
 {p=NULL; return p;}
 n=strcspn(saveline,delims);
 p=saveline;
 saveline+=n;
 if(*saveline='\0'){*saveline++='\0';}
 return(p);
}
*/
	 
void quitCB(Fl_Widget* a)
{
 exit(0);
}

void closedialogCB(Fl_Widget* a, void* data)
{
Fl_Window* d=(Fl_Window*) data;//strange type conversion..
d->~Fl_Window();
}


void quitdialogCB(Fl_Widget* a)
{
Fl_Window *dialogwindow=new Fl_Window(200,200,150,40,"Exit dialog");
Fl_Button *yesbutton=new Fl_Button(10,10,40,15,"Yes");
Fl_Button *nobutton=new Fl_Button(100,10,40,15,"No");
yesbutton->shortcut("y");
nobutton->shortcut("n");
dialogwindow->show();
yesbutton->callback(quitCB);
nobutton->callback(closedialogCB,(void*)dialogwindow);
}

void extractUCB(Fl_Widget* a, void* data)
{
 char buffer[110];
 int fileChosen=0;
 int validUnits=0;
 Fl_File_Chooser *openmapchooser=new  Fl_File_Chooser("/home/oleg/Downloads/fltk_prg/","*",Fl_File_Chooser::SINGLE,"Browse for soe2.exe file:");
 openmapchooser->show();
 while(openmapchooser->shown())
 {Fl::wait();}
 FILE *mapfile = fopen(openmapchooser->value(1),"r");
 if(mapfile!=NULL)
 { 
 FILE *weaponsfile = fopen("unitsout.csv","w");
 fprintf(weaponsfile,"namesize,name,country,pic,25-26,type,28-29,crews,inf./cost,cars,horses,MG,hand AT,APC,arm.cars,tanks,a.guns/max.aircraft,ATG,lm/cloHard,mm/medHard,hm/longHard,inf.art/sea def.,lig.art/cloSoft,h.art/medSoft,sh.art/fighters/longSoft,MRL/l.bomber/torpedo,light AA/bombers,h.AA/sea AA def./hvy bombers,speed,month,year,class,immob.,size\n");//writing header
 fprintf(stderr, "File chosen: '%s'\n",openmapchooser->value(1));
 int weaponN;
 for(weaponN=0;weaponN<UNITS;weaponN++)
 {
 int seekerror=fseek(mapfile,BINARYOFFSETU+UNITSIZE*weaponN,SEEK_SET);
 if(seekerror!=0){fprintf(stderr,"offset seek error %d\n",seekerror);}
 fread(buffer,0x6C,1,mapfile);
 namelength=buffer[unitFormatOffsets[0]];
 fprintf(weaponsfile,"%d,",namelength);
 strncpy(name,buffer+unitFormatOffsets[1],namelength);name[namelength]=0x00;//and null-terminating
 if(namelength!=0){validUnits++;}
 fprintf(weaponsfile,"%s,",name);
 strncpy(unitnames[weaponN+1],name,namelength);unitnames[weaponN+1][namelength]=0x00;//copy to names database as well to be used by scenario units extraction routine 
 countryU=(unsigned char)buffer[unitFormatOffsets[2]];
 unitOwnerIndex[weaponN+1]=countryU;//saving to global array to reuse in scenario extraction routine to attach unit owner
 fprintf(weaponsfile,"%s,",countries[countryU]);
 pic=(unsigned char)buffer[unitFormatOffsets[3]]+256*(unsigned char)buffer[unitFormatOffsets[3]+1];
 fprintf(weaponsfile,"%d,",pic);
 x25_26=(unsigned char)buffer[unitFormatOffsets[4]]+256*(unsigned char)buffer[unitFormatOffsets[4]+1];
 fprintf(weaponsfile,"%d,",x25_26); 
 typeU=(unsigned char)buffer[unitFormatOffsets[5]];
 fprintf(weaponsfile,"%s,",forcetype[typeU]); 
 x28_29=(unsigned char)buffer[unitFormatOffsets[6]]+256*(unsigned char)buffer[unitFormatOffsets[6]+1];
 fprintf(weaponsfile,"%d,",x28_29);
 crews=(unsigned char)buffer[unitFormatOffsets[7]]+256*(unsigned char)buffer[unitFormatOffsets[7]+1];
 fprintf(weaponsfile,"%d,",crews);
 infantry=(unsigned char)buffer[unitFormatOffsets[8]]+256*(unsigned char)buffer[unitFormatOffsets[8]+1];
 fprintf(weaponsfile,"%d,",infantry); 
 cars=(unsigned char)buffer[unitFormatOffsets[9]]+256*(unsigned char)buffer[unitFormatOffsets[9]+1];
 fprintf(weaponsfile,"%d,",cars);  
 horses=(unsigned char)buffer[unitFormatOffsets[10]]+256*(unsigned char)buffer[unitFormatOffsets[10]+1];
 fprintf(weaponsfile,"%d,",horses);
 MG=(unsigned char)buffer[unitFormatOffsets[11]]+256*(unsigned char)buffer[unitFormatOffsets[11]+1];
 fprintf(weaponsfile,"%d,",MG);
 handAT=(unsigned char)buffer[unitFormatOffsets[12]]+256*(unsigned char)buffer[unitFormatOffsets[12]+1];
 fprintf(weaponsfile,"%d,",handAT);
 APC=(unsigned char)buffer[unitFormatOffsets[13]]+256*(unsigned char)buffer[unitFormatOffsets[13]+1];
 fprintf(weaponsfile,"%d,",APC);
 armcars=(unsigned char)buffer[unitFormatOffsets[14]]+256*(unsigned char)buffer[unitFormatOffsets[14]+1];
 fprintf(weaponsfile,"%d,",armcars); 
 tanks=(unsigned char)buffer[unitFormatOffsets[15]]+256*(unsigned char)buffer[unitFormatOffsets[15]+1];
 fprintf(weaponsfile,"%d,",tanks);
 aguns=(unsigned char)buffer[unitFormatOffsets[16]]+256*(unsigned char)buffer[unitFormatOffsets[16]+1];
 fprintf(weaponsfile,"%d,",aguns); 
 ATG=(unsigned char)buffer[unitFormatOffsets[17]]+256*(unsigned char)buffer[unitFormatOffsets[17]+1];
 fprintf(weaponsfile,"%d,",ATG);  
 lm=(unsigned char)buffer[unitFormatOffsets[18]]+256*(unsigned char)buffer[unitFormatOffsets[18]+1];
 fprintf(weaponsfile,"%d,",lm);          
 mm=(unsigned char)buffer[unitFormatOffsets[19]]+256*(unsigned char)buffer[unitFormatOffsets[19]+1];
 fprintf(weaponsfile,"%d,",mm);  
 hm=(unsigned char)buffer[unitFormatOffsets[20]]+256*(unsigned char)buffer[unitFormatOffsets[20]+1];
 fprintf(weaponsfile,"%d,",hm); 
 infart=(unsigned char)buffer[unitFormatOffsets[21]]+256*(unsigned char)buffer[unitFormatOffsets[21]+1];
 fprintf(weaponsfile,"%d,",infart);   
 ligart=(unsigned char)buffer[unitFormatOffsets[22]]+256*(unsigned char)buffer[unitFormatOffsets[22]+1];
 fprintf(weaponsfile,"%d,",ligart);
 hart=(unsigned char)buffer[unitFormatOffsets[23]]+256*(unsigned char)buffer[unitFormatOffsets[23]+1];
 fprintf(weaponsfile,"%d,",hart); 
 shart=(unsigned char)buffer[unitFormatOffsets[24]]+256*(unsigned char)buffer[unitFormatOffsets[24]+1];
 fprintf(weaponsfile,"%d,",shart);    
 MRL=(unsigned char)buffer[unitFormatOffsets[25]]+256*(unsigned char)buffer[unitFormatOffsets[25]+1];
 fprintf(weaponsfile,"%d,",MRL);
 laa=(unsigned char)buffer[unitFormatOffsets[26]]+256*(unsigned char)buffer[unitFormatOffsets[26]+1];
 fprintf(weaponsfile,"%d,",laa); 
 haa=(unsigned char)buffer[unitFormatOffsets[27]]+256*(unsigned char)buffer[unitFormatOffsets[27]+1];
 fprintf(weaponsfile,"%d,",haa); 
 speedu=(unsigned char)buffer[unitFormatOffsets[28]];
 fprintf(weaponsfile,"%d,",speedu);
 month=(unsigned char)buffer[unitFormatOffsets[29]]+256*(unsigned char)buffer[unitFormatOffsets[29]+1];
 fprintf(weaponsfile,"%d,",month); 
 year=(unsigned char)buffer[unitFormatOffsets[30]]+256*(unsigned char)buffer[unitFormatOffsets[30]+1];
 fprintf(weaponsfile,"%d,",year); 
 classi=(unsigned char)buffer[unitFormatOffsets[31]];
 fprintf(weaponsfile,"%s,",typestring[classi]); 
 immob=(unsigned char)buffer[unitFormatOffsets[32]];
 fprintf(weaponsfile,"%d,",immob);
 unitsize=(unsigned char)buffer[unitFormatOffsets[33]];
 fprintf(weaponsfile,"%s",sizestring[unitsize]);          
 fprintf(weaponsfile,"\n");
 }
 fclose(mapfile);
 fclose(weaponsfile);
 }
 isUnitsNamesAvailable=TRUE;
 fprintf(stderr,"Total %d unit types were detected\n",validUnits);
}

void extractO(Fl_Widget* a, void* data)//extracts databases from SOE2 WWII scenario
{
char buffertile[MAPTILESIZE];
char bufferobject[MAPOBJECTSIZE];
 int fileChosen=0;
 unsigned short datar,datar2;//data item extracted from binary SCN file 
 unsigned short i;
 float lat,lon;
 Fl_File_Chooser *openmapchooser=new  Fl_File_Chooser("/home/oleg/Downloads/fltk_prg/","*",Fl_File_Chooser::SINGLE,"Browse for SCN file of SOE2:");
 openmapchooser->show();
 while(openmapchooser->shown())
 {Fl::wait();}
 FILE *mapfile = fopen(openmapchooser->value(1),"r");
 if(mapfile!=NULL)
 { 
  FILE *mapobjectfile = fopen("mapobjects.csv","w");
  fprintf(mapobjectfile,"Orig.,0x01,Curr.,0x03,Def/Eco,0x05,Type,0x08,0x09,0x0A,Name,X,Y,Handle,Lat.,Lon.\n");
  int x,y,offset;
  for(y=0;y<MAPROWS;y++)
  {
   for(x=0;x<MAPCOLUMNS;x++)
   {
    offset=MAPORIGIN+(y*MAPCOLUMNS+x)*MAPTILESIZE;
    int seekerror=fseek(mapfile,offset,SEEK_SET);
    if(seekerror!=0){fprintf(stderr,"offset seek error %d at row %d, column %d\n",seekerror,y,x);break;}
    fread(buffertile,MAPTILESIZE,1,mapfile);//reading tile
    datar=(unsigned char)buffertile[0]+256*(unsigned char)buffertile[1];//reading object handle if any
    if(datar!=0)
    {
     fprintf(stderr,"Detected object handle %d at x=%d, y=%d\n",datar,x,y);
     offset=CITIESOFFSET+datar*MAPOBJECTSIZE;
     int seekerror=fseek(mapfile,offset,SEEK_SET);
     if(seekerror!=0){fprintf(stderr,"offset seek error %d at handle %d\n",seekerror,datar);break;}
     fread(bufferobject,MAPOBJECTSIZE,1,mapfile);//reading object pointed by handle
     for(i=0;i<10;i++)//writing object byte fields
     {
      if((i!=0)&&(i!=2)&&(i!=6)){datar2=bufferobject[i];fprintf(mapobjectfile,"%d,",datar2);}//numerical fields
      if((i==0)||(i==2)){datar2=bufferobject[i];fprintf(mapobjectfile,"%s,",countries[datar2]);}//string field of type "country"
      if(i==6)	{//string field of special type "type"
		 if((datar>6000)&&(datar<=8000)){fprintf(mapobjectfile,"airbase,");}else
		 	{
			 if(datar>8000){if((bufferobject[6]>=5)&&(bufferobject[6]<=8)){fprintf(mapobjectfile,"medium fort,");};
			 		 if((bufferobject[6]>=9)&&(bufferobject[6]<=12)){fprintf(mapobjectfile,"small fort,");};
					 if((bufferobject[6]>=1)&&(bufferobject[6]<=4)){fprintf(mapobjectfile,"medium fort,");};
			 		}else//analyzing cities with pointer in 0-6000 range
					{
					 switch (bufferobject[6])
					 {
					 case 1:fprintf(mapobjectfile,"Metro (european),");break;
					 case 2:fprintf(mapobjectfile,"Metro (european),");break;
					 case 3:fprintf(mapobjectfile,"Metro (european),");break;
					 case 4:fprintf(mapobjectfile,"Metro (european),");break;					 
					 case 5:fprintf(mapobjectfile,"City (european),");break;
					 case 6:fprintf(mapobjectfile,"City (european),");break;
					 case 7:fprintf(mapobjectfile,"City (european),");break;
					 case 8:fprintf(mapobjectfile,"City (european),");break;					 
					 case 9:fprintf(mapobjectfile,"Town (european),");break;
					 case 10:fprintf(mapobjectfile,"Town (european),");break;
					 case 11:fprintf(mapobjectfile,"Town (european),");break;
					 case 12:fprintf(mapobjectfile,"Town (european),");break;
					 case 13:fprintf(mapobjectfile,"Village (european),");break;
					 case 14:fprintf(mapobjectfile,"Village (european),");break;
					 case 15:fprintf(mapobjectfile,"Village (european),");break;
					 case 16:fprintf(mapobjectfile,"Village (european),");break;					 
					 case 17:fprintf(mapobjectfile,"Metro (slavic),");break;
					 case 18:fprintf(mapobjectfile,"Metro (slavic),");break;
					 case 19:fprintf(mapobjectfile,"Metro (slavic),");break;
					 case 20:fprintf(mapobjectfile,"Metro (slavic),");break;					 
					 case 21:fprintf(mapobjectfile,"City (slavic),");break;
					 case 22:fprintf(mapobjectfile,"City (slavic),");break;
					 case 23:fprintf(mapobjectfile,"City (slavic),");break;
					 case 24:fprintf(mapobjectfile,"City (slavic),");break;					 
					 case 25:fprintf(mapobjectfile,"Town (slavic),");break;
					 case 26:fprintf(mapobjectfile,"Town (slavic),");break;
					 case 27:fprintf(mapobjectfile,"Town (slavic),");break;
					 case 28:fprintf(mapobjectfile,"Town (slavic),");break;
					 case 29:fprintf(mapobjectfile,"Village (slavic),");break;
					 case 30:fprintf(mapobjectfile,"Village (slavic),");break;
					 case 31:fprintf(mapobjectfile,"Village (slavic),");break;
					 case 32:fprintf(mapobjectfile,"Village (slavic),");break;					 
					 case 33:fprintf(mapobjectfile,"Metro (islamic),");break;
					 case 34:fprintf(mapobjectfile,"Metro (islamic),");break;
					 case 35:fprintf(mapobjectfile,"Metro (islamic),");break;
					 case 36:fprintf(mapobjectfile,"Metro (islamic),");break;					 
					 case 37:fprintf(mapobjectfile,"City (islamic),");break;
					 case 38:fprintf(mapobjectfile,"City (islamic),");break;
					 case 39:fprintf(mapobjectfile,"City (islamic),");break;
					 case 40:fprintf(mapobjectfile,"City (islamic),");break;					 
					 case 41:fprintf(mapobjectfile,"Town (islamic),");break;
					 case 42:fprintf(mapobjectfile,"Town (islamic),");break;
					 case 43:fprintf(mapobjectfile,"Town (islamic),");break;
					 case 44:fprintf(mapobjectfile,"Town (islamic),");break;
					 case 45:fprintf(mapobjectfile,"Village (islamic),");break;
					 case 46:fprintf(mapobjectfile,"Village (islamic),");break;
					 case 47:fprintf(mapobjectfile,"Village (islamic),");break;
					 case 48:fprintf(mapobjectfile,"Village (islamic),");break;					 
					 case 49:fprintf(mapobjectfile,"Metro (oriental),");break;
					 case 50:fprintf(mapobjectfile,"Metro (oriental),");break;
					 case 51:fprintf(mapobjectfile,"Metro (oriental),");break;
					 case 52:fprintf(mapobjectfile,"Metro (oriental),");break;					 
					 case 53:fprintf(mapobjectfile,"City (oriental),");break;
					 case 54:fprintf(mapobjectfile,"City (oriental),");break;
					 case 55:fprintf(mapobjectfile,"City (oriental),");break;
					 case 56:fprintf(mapobjectfile,"City (oriental),");break;					 
					 case 57:fprintf(mapobjectfile,"Town (oriental),");break;
					 case 58:fprintf(mapobjectfile,"Town (oriental),");break;
					 case 59:fprintf(mapobjectfile,"Town (oriental),");break;
					 case 60:fprintf(mapobjectfile,"Town (oriental),");break;
					 case 61:fprintf(mapobjectfile,"Village (oriental),");break;
					 case 62:fprintf(mapobjectfile,"Village (oriental),");break;
					 case 63:fprintf(mapobjectfile,"Village (oriental),");break;
					 case 64:fprintf(mapobjectfile,"Village (oriental),");break;
					 case 65:fprintf(mapobjectfile,"Port (facing N),");break;
					 case 66:fprintf(mapobjectfile,"Port (facing S),");break;
					 case 67:fprintf(mapobjectfile,"Port (facing E),");break;
					 case 68:fprintf(mapobjectfile,"Port (facing NE),");break;
					 case 69:fprintf(mapobjectfile,"Port (facing NW),");break;
					 case 70:fprintf(mapobjectfile,"Port (facing W),");break;
					 case 71:fprintf(mapobjectfile,"Port (facing SW),");break;
					 case 72:fprintf(mapobjectfile,"Port (facing SE),");break;
					 }
					}
			}
		
       		
	   }	
     }    
     strncpy(name,bufferobject+10,MAXNAMELENGTHOBJECT);name[MAXNAMELENGTHOBJECT]=0x00;//reading unit name and null-terminating
     fprintf(mapobjectfile,"%s,",name);//writing object name
     fprintf(mapobjectfile,"%d,",x);//combining map and object data 
     fprintf(mapobjectfile,"%d,",y);//combining map and object data
     fprintf(mapobjectfile,"%d,",datar);//saving object handle for type disambiguation
     lat=getLatitude(y);
     lon=getLongitude(x);
     fprintf(mapobjectfile,"%6.2f,%6.2f\n",lat,lon);//writting estimated latitude/longitude and terminating the line      
    }
   }
      
  }
  fclose(mapfile);
  fclose(mapobjectfile);
 }

}  
void extractSCN(Fl_Widget* a, void* data)//extracts databases from SOE2 WWII scenario
{
 char currline[MAXLINELENGTH];//for reading line of text format
  int linenum=0;int column;//used to parse created database again and detach units
  char *token;int isNumber;unsigned int *valPtr;unsigned int val[UNITDBFIELDS+1];//used to parse created database again and detach units
 unsigned char buffer[UNITDBSIZE];
 int fileChosen=0;
 int detached=0;//counter of detached units;
 unsigned short datar,datar2;//data item extracted from binary SCN file 
 float lat,lon;
 Fl_File_Chooser *openmapchooser=new  Fl_File_Chooser("/home/oleg/Downloads/fltk_prg/","*",Fl_File_Chooser::SINGLE,"Browse for SCN file of SOE2:");
 openmapchooser->show();
 while(openmapchooser->shown())
 {Fl::wait();}
 FILE *mapfile = fopen(openmapchooser->value(1),"r");
 if(mapfile!=NULL)
 { 
 FILE *unitsdbfile = fopen("unitsdb.csv","w");                                                         fprintf(unitsdbfile,"Index,X,Y,Lat.,Lon.,Owner,Class,0x06,0x07,Exp.,Mor.,Ammo,0x0B,Name,Crews,Infantry,Cars,Pack,A1,A2,A3,A4,HMG,ATR,APC1,APC2,A.car1,A.car2,Tank1,Tank2,Tank3,Tank4,Tank5,A.gun1,A.gun2,A.gun3,ATG1,ATG2,ATG3,ATG4,L.m.,M.m.1,Hm1,Hm2,Ig1,Ig2,La1,La2,Ha1,Ha2,Ha3,SHa1/Fighters1,SHa2/Fighters2,SHa3/Fighters3,MRL1/Tact.Bomber1,MRL2/Tact.Bombers2,lAA1/Bombers1,lAA2/Bombers2,lAA3/Bombers3,hAA1/H.Bombers1,hAA2/H.Bombers2,Actions,Damage\n");//writing header
 fprintf(stderr, "File chosen: '%s'\n",openmapchooser->value(1));
 int unitN;//binary block number
 int i,ii;//counter of data items in binary block
 for(unitN=0;unitN<UNITSDBLIMIT;unitN++)
  {
  int seekerror=fseek(mapfile,BINARYOFFSETUDB+unitN*UNITDBSIZE,SEEK_SET);
  if(seekerror!=0){fprintf(stderr,"offset seek error %d at line %d\n",seekerror,unitN);break;}
  fread(buffer,UNITDBSIZE,1,mapfile);
   unsigned short x=(unsigned char)buffer[0]+256*(unsigned char)buffer[1];//reading unit map coordinates, must be non-zero for existing units
   unsigned short y=(unsigned char)buffer[2]+256*(unsigned char)buffer[3];
  if((x!=0)||(y!=0))//if unit exist 
   {
   fprintf(unitsdbfile,"%d,%d,%d,",unitN+1,x,y);//saving unit index and map coordinates
      //starting calculation of geographic coordinates
     lat=getLatitude(y);
     lon=getLongitude(x);
     fprintf(unitsdbfile,"%6.2f,%6.2f,",lat,lon);//writting estimated latitude/longitude
     if(x!=OFFMAP6)//saving directly only 1st unit in stack
     {
     unitcoordinates[unitN+1][XX]=x;unitcoordinates[unitN+1][YY]=y;//saving to in-memory array to detach units in 2nd pass
     unitcoordinatesf[unitN+1][YLAT]=lat;unitcoordinatesf[unitN+1][XLON]=lon;//saving to in-memory array to detach units in 2nd pass
     }  
     //finished geographic coordinates calculation   
   datar=(unsigned char)buffer[4]+256*(unsigned char)buffer[5];//extracting index of unit class
   if(isUnitsNamesAvailable==FALSE){fprintf(unitsdbfile,"see unitsout.csv,%d,",datar);}else//print only unit indices if units database was not extracted in session
		  {fprintf(unitsdbfile,"%s,%s,",countries[unitOwnerIndex[datar]],unitnames[datar]);}
	          
  for(i=6;i<12;i++) 
   {datar=buffer[i];fprintf(unitsdbfile,"%d,",datar);}//writing flag 0x06, flag 0x07, experience, morale, ammo, flag 11
   strncpy(name,buffer+0x0C,MAXNAMELENGTHUDB);name[MAXNAMELENGTHUDB]=0x00;//reading unit name and null-terminating
  fprintf(unitsdbfile,"%s,",name); 
  for(i=14;i<23;i++)//reading non-typed unit contents (crews to HMG)
   {
   datar=(unsigned char)buffer[i*2]+256*(unsigned char)buffer[i*2+1];
   fprintf(unitsdbfile,"%d,",datar);
   if((i>=18)&&(i<=21)&&(datar!=0))//saving coordinates of attached units for detaching
   	{
	unitcoordinates[datar+1][XX]=x;unitcoordinates[datar+1][YY]=y;
	unitcoordinatesf[datar+1][XLON]=lon;unitcoordinatesf[datar+1][YLAT]=lat;
	}
   }
  for(i=11;i<49;i++)//reading typed unit contents (ATR to heavy AD slot 3)
   {
   datar=(unsigned char)buffer[i*4+2]+256*(unsigned char)buffer[i*4+3];
   datar2=(unsigned char)buffer[i*4+4]+256*(unsigned char)buffer[i*4+5];
   if(datar!=0){
   		if(isWeaponsNamesAvailable==FALSE){fprintf(unitsdbfile,"%d*%d,",datar,datar2);}else//print only weapon indices if 
		{fprintf(unitsdbfile,"%d*%s,",datar,weaponnames[datar2]);}
	       }else{fprintf(unitsdbfile,"NULL,");}
   }   
  for(i=198;i<200;i++) 
   {datar=buffer[i];if(i<199){fprintf(unitsdbfile,"%d,",datar);}else{fprintf(unitsdbfile,"%d\n",datar);}}//writing actions and flag 199, terminating line at last token    
  //fprintf(unitsdbfile,"\n");//terminating line for the current unit
  }//end of "if unit exist"
  }//end of current unit analysis, do nothing if unit do not exist
 fclose(mapfile);
 fclose(unitsdbfile); 
 fprintf(stderr,"scenario units data extraction complete, starting detaching units coordinate data\n");
 unitsdbfile = fopen("unitsdb.csv","r");
 FILE *unitsdb2file = fopen("unitsdb2.csv","w");
 fprintf(unitsdb2file,"Index,X,Y,Lat.,Lon.,Owner,Class,0x06,0x07,Exp.,Mor.,Ammo,0x0B,Name,Crews,Infantry,Cars,Pack,A1,A2,A3,A4,HMG,ATR,APC1,APC2,A.car1,A.car2,Tank1,Tank2,Tank3,Tank4,Tank5,A.gun1,A.gun2,A.gun3,ATG1,ATG2,ATG3,ATG4,L.m.,M.m.1,Hm1,Hm2,Ig1,Ig2,La1,La2,Ha1,Ha2,Ha3,SHa1/Fighters1,SHa2/Fighters2,SHa3/Fighters3,MRL1/Tact.Bomber1,MRL2/Tact.Bombers2,lAA1/Bombers1,lAA2/Bombers2,lAA3/Bombers3,hAA1/H.Bombers1,hAA2/H.Bombers2,Actions,Damage\n");//writing header
 unsigned int currindex;//index of current unit
 fgets(currline,MAXLINELENGTH,unitsdbfile);//skipping header of csv file 
 while(fgets(currline,MAXLINELENGTH,unitsdbfile))//read while lines are non-zero
  {
   linenum++;column=0;
   token=strtok(currline,",");//getting a column
   valPtr=&currindex;
   isNumber=a2i(token,valPtr);
   fprintf(unitsdb2file,"%s,",token);   
   while(token!=NULL)
   {
   token=strtok(NULL,",");//getting a column
   valPtr=&val[column];
   isNumber=a2i(token,valPtr);
   if(((column==0)&&(val[column]==OFFMAP6))||((column==1)&&(val[column]==OFFMAP6))||((column==2)&&(atof(token)<OFFMAPFMAX))||((column==3)&&(atof(token)<OFFMAPFMAX)))//if detaching necessary
    {
     //fprintf(stderr,"detaching unit with index %d\n",currindex);
     if(column==0){fprintf(unitsdb2file,"%d,",unitcoordinates[currindex+1][XX]);detached++;}
     if(column==1){fprintf(unitsdb2file,"%d,",unitcoordinates[currindex+1][YY]);}
     if(column==2){fprintf(unitsdb2file,"%6.2f,",unitcoordinatesf[currindex+1][YLAT]);}
     if(column==3){fprintf(unitsdb2file,"%6.2f,",unitcoordinatesf[currindex+1][XLON]);}
    }else
     {
     if(token!=NULL){if(column<UNITDBFIELDS-2){fprintf(unitsdb2file,"%s,",token);}else{fprintf(unitsdb2file,"%s",token);}}//if no change necessary, just copy the values
     }
   column++;
   }
  }
 fprintf(stderr,"%d units were detached\n",detached);
 fclose(unitsdbfile);
 fclose(unitsdb2file);
 fprintf(stderr,"the database re-read and units deattach completed, %d lines\n",linenum); 
 } 
}

void extractCB(Fl_Widget* a, void* data)
{
 char buffer[110];
 int fileChosen=0;
 Fl_File_Chooser *openmapchooser=new  Fl_File_Chooser("/home/oleg/Downloads/fltk_prg/","*",Fl_File_Chooser::SINGLE,"Browse for soe2.exe file:");
 openmapchooser->show();
 while(openmapchooser->shown())
 {Fl::wait();}
 FILE *mapfile = fopen(openmapchooser->value(1),"r");
 if(mapfile!=NULL)
 { 
 FILE *weaponsfile = fopen("weaponsout.csv","w");
 fprintf(weaponsfile,"class,namesize,name,month,year,price,speed,agil.,s.att.,h.att,a.att.,g.def.,a.def.,3E,range,immob,A,BE,BU,CA,CH,SI,CR,CZ,FI,FR,FRV,G,GB,GR,H,IND,IRAN,IT,J,D,M,NE,NZ,NO,IRAQ,POL,POR,R,SL,SF,SR,SA,SWE,SWI,T,US,USSR,Y,CanUpgrade\n");//writing header
 fprintf(stderr, "File chosen: '%s'\n",openmapchooser->value(1));
 int weaponN;
 int validWeapons=0;
 for(weaponN=0;weaponN<WEAPONS;weaponN++)
 {
 int seekerror=fseek(mapfile,BINARYOFFSET+WEAPONSIZE*weaponN,SEEK_SET);
 if(seekerror!=0){fprintf(stderr,"offset seek error %d\n",seekerror);}
 fread(buffer,0x6C,1,mapfile);
 wclass=buffer[weaponFormatOffsets[0]];
 fprintf(weaponsfile,"%d,",wclass);
 namelength=buffer[weaponFormatOffsets[1]];
 fprintf(weaponsfile,"%d,",namelength);
 strncpy(name,buffer+weaponFormatOffsets[2],namelength);name[namelength]=0x00;//and null-terminating
 fprintf(weaponsfile,"%s,",name);
 strncpy(weaponnames[weaponN+1],name,namelength);weaponnames[weaponN+1][namelength]=0x00;//and null-terminating
 if(namelength>0){validWeapons++;}
 month=buffer[weaponFormatOffsets[3]]+256*buffer[weaponFormatOffsets[3]+1];
 fprintf(weaponsfile,"%d,",month);
 year=(unsigned char)buffer[weaponFormatOffsets[4]]+256*(unsigned char)buffer[weaponFormatOffsets[4]+1];
 fprintf(weaponsfile,"%d,",year);
 price=(unsigned char)buffer[weaponFormatOffsets[5]]+256*(unsigned char)buffer[weaponFormatOffsets[5]+1];
 fprintf(weaponsfile,"%d,",price);
 speed=(unsigned char)buffer[weaponFormatOffsets[6]]+256*(unsigned char)buffer[weaponFormatOffsets[6]+1];
 fprintf(weaponsfile,"%d,",speed);
 maneurability=(unsigned char)buffer[weaponFormatOffsets[7]]+256*(unsigned char)buffer[weaponFormatOffsets[7]+1];
 fprintf(weaponsfile,"%d,",maneurability);
 softattack=(unsigned char)buffer[weaponFormatOffsets[8]]+256*(unsigned char)buffer[weaponFormatOffsets[8]+1];
 fprintf(weaponsfile,"%d,",softattack);
 hardattack=(unsigned char)buffer[weaponFormatOffsets[9]]+256*(unsigned char)buffer[weaponFormatOffsets[9]+1];
 fprintf(weaponsfile,"%d,",hardattack); 	
 airattack=(unsigned char)buffer[weaponFormatOffsets[10]]+256*(unsigned char)buffer[weaponFormatOffsets[10]+1];
 fprintf(weaponsfile,"%d,",airattack);
 grounddefence=(unsigned char)buffer[weaponFormatOffsets[11]]+256*(unsigned char)buffer[weaponFormatOffsets[11]+1];
 fprintf(weaponsfile,"%d,",grounddefence); 
 airdefence=(unsigned char)buffer[weaponFormatOffsets[12]]+256*(unsigned char)buffer[weaponFormatOffsets[12]+1];
 fprintf(weaponsfile,"%d,",airdefence);
 flag3E=(unsigned char)buffer[weaponFormatOffsets[13]]+256*(unsigned char)buffer[weaponFormatOffsets[13]+1];
 fprintf(weaponsfile,"%d,",flag3E);
 range=(unsigned char)buffer[weaponFormatOffsets[14]]+256*(unsigned char)buffer[weaponFormatOffsets[14]+1];
 fprintf(weaponsfile,"%d,",range); 
 flag42=(unsigned char)buffer[weaponFormatOffsets[15]]+256*(unsigned char)buffer[weaponFormatOffsets[15]+1];
 fprintf(weaponsfile,"%d,",flag42); 
 int i;
 for(i=0;i<COUNTRIES;i++)
 	{
	country[i]=buffer[weaponFormatOffsets[WEAPONFIELDS-1]+i];
	fprintf(weaponsfile,"%d,",country[i]);
	//if(country[i]==1){fprintf(stderr,"country %d present\n",i);}
	}
   canUpgrade=(unsigned char)buffer[weaponFormatOffsets[WEAPONFIELDS]]+256*(unsigned char)buffer[weaponFormatOffsets[WEAPONFIELDS]+1];
   fprintf(weaponsfile,"%d",canUpgrade); 		
  fprintf(weaponsfile,"\n");
 	
 }
	 
 fclose(mapfile);
 fclose(weaponsfile);
 isWeaponsNamesAvailable=TRUE;
 fprintf(stderr,"Extraction completed, %d weapons written\n",validWeapons);
 }
}

void embedCB(Fl_Widget* a, void* data)
{
 char currline[MAXLINELENGTH];//for reading line of text format
 char writebuffer[110];//for writing binary format
 int linenum=0;int column;char *token;int isNumber;int seekerror;
 int fileChosen=0;
 unsigned int *valPtr;
 unsigned int val[FIELDS+1];
 Fl_File_Chooser *openmapchooser=new  Fl_File_Chooser("/home/oleg/Downloads/fltk_prg/","*",Fl_File_Chooser::SINGLE,"Browse the soe2.exe file:");
 openmapchooser->show();
 while(openmapchooser->shown())
 {Fl::wait();}
 FILE *mapfile = fopen(openmapchooser->value(1),"r+");
 if(mapfile!=NULL)
 {
 FILE *weaponsfile = fopen("weaponsout.csv","r");
 fgets(currline,MAXLINELENGTH,weaponsfile);//skipping header of csv file
 while((fgets(currline,MAXLINELENGTH,weaponsfile))&&(linenum<WEAPONS))//read while lines are non-zero (non-EOF) or until enough data read 
 {
   int seekerror=fseek(mapfile,BINARYOFFSET+WEAPONSIZE*linenum,SEEK_SET);//setting address where data will be written
   linenum++;column=0;
   memset(writebuffer,0x00,110);//wiping out previous data and filling buffer with zeros;
   //fprintf(stderr,"line=%d\n",linenum);
   token=strtok(currline,",");
   valPtr=&val[column];
   isNumber=a2i(token,valPtr);
   if((isNumber!=0)&&(val[column]!=0))//writing back only non-zero entries
   {
    writebuffer[weaponFormatOffsets[column]]=(char)val[column];//writing weapon class
    //printf("weapon class %d detected\n",writebuffer[weaponFormatOffsets[column]]);	   
    while(token!=NULL)
    {
    token=strtok(NULL,",");
    column++;
    if(column==1){//writing length of name
   		  valPtr=&val[column];
   		  isNumber=a2i(token,valPtr);
		  if(isNumber==0){printf("Error:non-numeric value %s at name length field at line %d!\n",token,linenum);}    		  
    		  writebuffer[weaponFormatOffsets[column]]=(char)val[column];
		  if(writebuffer[weaponFormatOffsets[column]]>MAXNAMELENGTH){fprintf(stderr,"The length of name in line %d set above 40 to %d, exiting\n",linenum,writebuffer[weaponFormatOffsets[column]]);exit(2);}
		 } 
    if(column==2){//writing name
    		  writebuffer[weaponFormatOffsets[column]]=(char)val[column];
		  //fprintf(stderr,"warning:incorrect length set=%d, act=%d, of name '%s' set at line %d\n",writebuffer[weaponFormatOffsets[1]],strlen(token),token,linenum);
		  if((char)strlen(token)!=writebuffer[weaponFormatOffsets[1]]){
		  	fprintf(stderr,"warning:incorrect length set=%d, actual=%d, of name '%s' at line %d",writebuffer[weaponFormatOffsets[1]],strlen(token),token,linenum);
			if(strlen(token)<=MAXNAMELENGTH){writebuffer[weaponFormatOffsets[1]]=strlen(token);fprintf(stderr,"..automatically corrected\n");}else{fprintf(stderr,"..name length>40, can not correct, exiting\n");exit(1);}
									      }//detected name size error
		  strcpy(&writebuffer[weaponFormatOffsets[2]],token);
		 }
     if((column>=3)&&(column<=(WEAPONFIELDS-2)))
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		writebuffer[weaponFormatOffsets[column]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[weaponFormatOffsets[column]]=(val[column] % 256);//saving lower byte
		if((val[column]>65535)||(val[column]<0)){fprintf(stderr,"too large parameter equal to %d in line %d, exiting\n",val[column],linenum);exit(3);}		  
		 }
     if((column>=(WEAPONFIELDS-1))&&(column<=(FIELDS-1)))
     		 {
  		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if((val[column]<0)||(val[column]>1)){fprintf(stderr,"erroneous country flag %d in line %d, column %d, must be 0 or 1, exiting\n",val[column],linenum,column);exit(4);}
		writebuffer[weaponFormatOffsets[WEAPONFIELDS-1]+(column-(WEAPONFIELDS-1))]=(char)(val[column]);		 
		 }			 			  
     }     
     if(column==FIELDS)
     		{
  		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if((val[column]<0)||(val[column]>10)){fprintf(stderr,"erroneous canUpgrade value %d in line %d, column %d, must be 0 to 10, exiting\n",val[column],linenum,column);exit(5);}
		writebuffer[weaponFormatOffsets[WEAPONFIELDS]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[weaponFormatOffsets[WEAPONFIELDS]]=(val[column] % 256);//saving lower byte		 		
		}
   }
   fwrite(writebuffer,108,1,mapfile);//dumping buffer with 1 weapon data back to file, last 2-byte field not written
 }
 fclose(mapfile);
 fclose(weaponsfile);
 fprintf(stderr,"Embedding of database to %s file complete\n",openmapchooser->value(1));
 }
}

void embedCBU(Fl_Widget* a, void* data)
{
 char currline[MAXLINELENGTH];//for reading line of text format
 char writebuffer[110];//for writing binary format
 int linenum=0;int column;char *token;int isNumber;int seekerror;
 int fileChosen=0;
 int i,succ;
 unsigned int *valPtr;
 unsigned int val[FIELDS+1];
 Fl_File_Chooser *openmapchooser=new  Fl_File_Chooser("/home/oleg/Downloads/fltk_prg/","*",Fl_File_Chooser::SINGLE,"Browse the soe2.exe file:");
 openmapchooser->show();
 while(openmapchooser->shown())
 {Fl::wait();}
 FILE *mapfile = fopen(openmapchooser->value(1),"r+");
 if(mapfile!=NULL)
 {
 FILE *weaponsfile = fopen("unitsout.csv","r");
 fgets(currline,MAXLINELENGTH,weaponsfile);//skipping header of csv file
 while((fgets(currline,MAXLINELENGTH,weaponsfile))&&(linenum<UNITS))//read while lines are non-zero (non-EOF) or until enough data read 
 {
   int seekerror=fseek(mapfile,BINARYOFFSETU+UNITSIZE*linenum,SEEK_SET);//setting address where data will be written
   linenum++;column=0;
   memset(writebuffer,0x00,110);//wiping out previous data and filling buffer with zeros;
   //fprintf(stderr,"line=%d\n",linenum);
   token=strtok(currline,",");
   valPtr=&val[column];
   isNumber=a2i(token,valPtr);
   if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at name length), line %d\n",linenum);exit(3);}
   if((isNumber!=0)&&(val[column]!=0))//writing back only non-zero entries
   {   
   writebuffer[unitFormatOffsets[column]]=(char)val[column];//writing length of name
   //fprintf(stderr,"name length=%d\n",val[column]);
   if(writebuffer[unitFormatOffsets[column]]>MAXUNITNAMELENGTH){fprintf(stderr,"The length of name in line %d set above 33, exiting",linenum);exit(2);}	   
    while(token!=NULL)
    {
    token=strtok(NULL,",");
    column++;
    //fprintf(stderr,"processing column %d\n",column);    
    if(column==1){//writing name
    		  writebuffer[unitFormatOffsets[column]]=(char)val[column];
		  //printf("name=%s of length %d\n",token,(char)strlen(token));
		  
		  if((char)strlen(token)!=writebuffer[unitFormatOffsets[0]]){
		  	fprintf(stderr,"warning:incorrect length set=%d, actual=%d, of name '%s' at line %d",writebuffer[unitFormatOffsets[0]],strlen(token),token,linenum);
			if(strlen(token)<=MAXNAMELENGTH){writebuffer[unitFormatOffsets[0]]=strlen(token);fprintf(stderr,"..automatically corrected\n");}else{fprintf(stderr,"..name length>33, can not correct, exiting\n");exit(1);}
									      }//detected name size error
		  strcpy(&writebuffer[unitFormatOffsets[1]],token);
		 }
     if(column==2)//country - need decoding from text
     		 {
		  succ=0;i=COUNTRIES+1;
		  while((i>=0)&&(succ==0))
			{
			i--;
			if(strncmp(token,countries[i],MAXUNITNAMELENGTH)==0){val[column]=i;succ=1;}
			}
		  if(succ==0){val[column]=0;}//no country set or no match	
		writebuffer[unitFormatOffsets[column]]=(char)(val[column]);//saving byte, 0 if no match
		if((val[column]>COUNTRIES)||(val[column]<0)){fprintf(stderr,"Erroneous country code %d in line %d, exiting\n",val[column],linenum);exit(3);}		  
		 }
		 
     if(column==3)
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at picture number), line %d\n",linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[unitFormatOffsets[column]]=(val[column] % 256);//saving lower byte
		if((val[column]>MAXPICS)||(val[column]<0)){fprintf(stderr,"Erroneous picture number must be 0 to 281:  %d in line %d, exiting\n",val[column],linenum);exit(3);}		  
		 }
     if(column==4)
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at unknown flag 0x25-0x26), line %d\n",linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[unitFormatOffsets[column]]=(val[column] % 256);//saving lower byte
		if((val[column]>0)||(val[column]<0)){fprintf(stderr,"Warning! erroneous (likely) flag %d 25_26: (known valid value is only 0) in line %d\n",val[column],linenum);}		  
		 }		  			 			  
     if(column==5)//forcetype (land, sea, air) - need decoding from text
     		 {
		  succ=0;i=FORCETYPES+1;
		  while((i>=0)&&(succ==0))
			{
			i--;
			if(strncmp(token,forcetype[i],MAXUNITNAMELENGTH)==0){val[column]=i;succ=1;}
			}
		  if(succ==0){val[column]=0;}//no forcetype set or no match	
		writebuffer[unitFormatOffsets[column]]=(char)(val[column]);//saving byte, 0 if no match
		if((val[column]>FORCETYPES)||(val[column]<0)){fprintf(stderr,"Erroneous forcetype code %d in line %d, exiting\n",val[column],linenum);exit(3);}		  
		 }
     if(column==6)
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at unknown flag 0x28-0x29), line %d\n",linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[unitFormatOffsets[column]]=(val[column] % 256);//saving lower byte
		if((val[column]!=0)&&(val[column]!=16)){fprintf(stderr,"Warning! erroneous (likely) flag %d 28_29: (known valid values are 0 or 16) in line %d\n",val[column],linenum);}		  
		 }
     if((column>=6)&&(column<=27))//saving bulk of data - standard 2-byte parameters of units
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at column %s, line %d\n",colstring[column],linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[unitFormatOffsets[column]]=(val[column] % 256);//saving lower byte
		if(((val[column])<0)||((val[column])>65535)){fprintf(stderr,"Error! Value %d outsize of short range (0-65535) at column %s in line %d\n",(val[column]+val[column+1]*256),colstring[column],linenum);exit(3);}		  
		 }
     if(column==28)//speed
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at speed), line %d\n",linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]]=(val[column]);//saving byte
		if((val[column]>255)||(val[column]<0)){fprintf(stderr,"Error! Speed set to %d in line %d, must be in 0-255 range\n",val[column],linenum);exit(3);}		  
		 }
     if(column==29)//month of availability
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at month of availability), line %d\n",linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[unitFormatOffsets[column]]=(val[column] % 256);//saving lower byte
		if((val[column]<1)||(val[column]>12)){fprintf(stderr,"Error! Month must be 1 to 12, but set to %d in line %d\n",val[column],linenum);exit(3);}		  
		 }
     if(column==30)//year of availability
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at month of availability), line %d\n",linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]+1]=(char)(val[column]/256);//saving upper byte
		writebuffer[unitFormatOffsets[column]]=(val[column] % 256);//saving lower byte
		if((val[column]<1)||(val[column]>3000)){fprintf(stderr,"Error! Year must be 1 to 3000, but set to %d in line %d\n",val[column],linenum);exit(3);}		  
		 }
     if(column==31)//force detailed type (artillery, infantry, destroyer, bombers fleet etc..) - need decoding from text
     		 {
		  succ=0;i=UNITTYPES+1;
		  while((i>=0)&&(succ==0))
			{
			i--;
			if(strncmp(token,typestring[i],MAXUNITNAMELENGTH)==0){val[column]=i;succ=1;}
			}
		  if(succ==0){val[column]=0;}//no forcetype set or no match	
		writebuffer[unitFormatOffsets[column]]=(char)(val[column]);//saving byte, 0 if no match
		if((val[column]>UNITTYPES)||(val[column]<0)){fprintf(stderr,"Erroneous unittype code %d in line %d, must be 0 to 44, exiting\n",val[column],linenum);exit(3);}		  
		 }
     if(column==32)//movement type 0-land, 1-low mobility, 2-sea
     		 {
    		valPtr=&val[column];	   
    		isNumber=a2i(token,valPtr);
		if(isNumber==0){fprintf(stderr,"Error:NAN there number expected (at immobility/movement type field), line %d\n",linenum);exit(3);}
		writebuffer[unitFormatOffsets[column]]=(val[column]);//saving byte
		if((val[column]>2)||(val[column]<0)){fprintf(stderr,"Error! Mobility set to %d in line %d, must be in 0-2 range\n",val[column],linenum);exit(3);}		  
		 }
     if(column==33)//force size (1-division, 2-regiment/brigade, 3-battalion) - need decoding from text
     		 {
		  
		  succ=0;i=SIZETYPES+1;
		  while((i>=0)&&(succ==0))
			{
			i--;
			if(strncmp(token,sizestring[i],MAXUNITSIZELENGTH)==0){val[column]=i;succ=1;}
			}
		  if(succ==0){val[column]=0;}//no forcetype set or no match	
		writebuffer[unitFormatOffsets[column]]=(char)(val[column]);//saving byte, 0 if no match
		//printf("unit size %d placed at line %d, success=%d\n",i,linenum,succ);
		if((val[column]>UNITTYPES)||(val[column]<0)){fprintf(stderr,"Erroneous sizetype code %d in line %d, must be 0 to 2, exiting\n",val[column],linenum);exit(3);}		  
		 }		 		 		 		 		 		  			 			 		 		 
     } 
    }     
   fwrite(writebuffer,92,1,mapfile);//dumping buffer with 1 unit data back to file
 }
 fclose(mapfile);
 fclose(weaponsfile);
 fprintf(stderr,"Embedding of database to %s file complete\n",openmapchooser->value(1));
 }
}

int main(int argc, char **argv)
{
 Fl_Window *mainwindow=new Fl_Window(320,200,"SOE2 tech import/export");
 Fl_Menu_Bar *mainmenu=new Fl_Menu_Bar(0,0,460,15);
 mainmenu->add("&Extract weapons",FL_COMMAND+'x',(Fl_Callback *)extractCB);
 mainmenu->add("&extract Units db",FL_COMMAND+'u',(Fl_Callback *)extractUCB);
  mainmenu->add("&Exit",FL_COMMAND+'e',(Fl_Callback *)quitdialogCB);
 Fl_Button *extractScnUnitsButton=new Fl_Button(10,20,240,32,"extract Scenario units data");
 extractScnUnitsButton->shortcut("s"); 
 Fl_Button *embedButton=new Fl_Button(10,60,240,32,"embed Weapons");
 embedButton->shortcut("w");
 Fl_Button *embedUButton=new Fl_Button(10,100,240,32,"eMbed units");
 embedUButton->shortcut("m"); 
 Fl_Button *extractOButton=new Fl_Button(10,140,240,32,"extract map Objects (cities etc.)");
 extractOButton->shortcut("o");  
 mainwindow->end();
 mainwindow->show(argc,argv);
 extractScnUnitsButton->callback(extractSCN,(void*)mainwindow);
 embedButton->callback(embedCB,(void*)mainwindow);
 embedUButton->callback(embedCBU,(void*)mainwindow);
 extractOButton->callback(extractO,(void*)mainwindow);
 return Fl::run();
}
